=== removed file 'l10n_mx_facturae_cbb/report/amount_to_text_es.py'
--- l10n_mx_facturae_cbb/report/amount_to_text_es.py	2012-02-24 00:42:55 +0000
+++ l10n_mx_facturae_cbb/report/amount_to_text_es.py	1970-01-01 00:00:00 +0000
@@ -1,158 +0,0 @@
-# -*- encoding: utf-8 -*-
-###########################################################################
-#    Module Writen to OpenERP, Open Source Management Solution
-#
-#    Copyright (c) 2010 Vauxoo - http://www.vauxoo.com/
-#    All Rights Reserved.
-#    info Vauxoo (info@vauxoo.com)
-############################################################################
-#    Coded by: moylop260 (moylop260@vauxoo.com)
-#    Launchpad Project Manager for Publication: Nhomar Hernandez - nhomar@vauxoo.com
-############################################################################
-#
-#    This program is free software: you can redistribute it and/or modify
-#    it under the terms of the GNU Affero General Public License as
-#    published by the Free Software Foundation, either version 3 of the
-#    License, or (at your option) any later version.
-#
-#    This program is distributed in the hope that it will be useful,
-#    but WITHOUT ANY WARRANTY; without even the implied warranty of
-#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#    GNU Affero General Public License for more details.
-#
-#    You should have received a copy of the GNU Affero General Public License
-#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
-#
-##############################################################################
-
-class amount_to_text:
-    """
-    Transforma de una cantidad numerica a cantidad en letra
-    ej. 200 -> doscientos
-    """
-
-    def __init__(self):
-        self._n1 = ( "un","dos","tres","cuatro","cinco","seis","siete","ocho",
-            "nueve","diez","once","doce","trece","catorce","quince",
-            "dieciseis","diecisiete","dieciocho","diecinueve","veinte")
-
-        self._n11 =( "un","dos","tres","cuatro","cinco","seis","siete","ocho","nueve")
-
-        self._n2 = ( "dieci","veinti","treinta","cuarenta","cincuenta","sesenta",
-                "setenta","ochenta","noventa")
-
-        self._n3 = ( "ciento","dosc","tresc","cuatroc","quin","seisc",
-                "setec","ochoc","novec")
-    
-    def amount_to_text_cheque(self, nNumero, intermedio="pesos ", sufijo="M. N." ):
-        nNumero = round( nNumero , 2)
-        strCantEntera = self.amount_to_text(nNumero)
-        intCantDecimal = self.extraeDecimales( nNumero )
-        if intCantDecimal<=9:
-            strCantDecimal="0%d"%(intCantDecimal)
-        else:
-            strCantDecimal="%d"%(intCantDecimal)
-        strCantDecimal += "/100"
-        return strCantEntera+' '+intermedio+' '+strCantDecimal+' '+sufijo
-    
-    def extraeDecimales(self, nNumero, max_digits=2):
-        strDecimales = str( round(nNumero%1, 2) ).replace('0.','')
-        strDecimales += "0"*max_digits
-        strDecimales = strDecimales[0:max_digits]
-        return long( strDecimales )
-    
-    def amount_to_text(self, nNumero, lFemenino=False):
-        """
-        NOTA: Solo numeros ENTEROS, omite los DECIMALES.
-        amount_to_text(nNumero, lFemenino) --> cLiteral
-            Convierte el numero a una cadena literal de caracteres
-        P.e.:       201     -->   "doscientos uno"
-                    1111     -->   "mil ciento once"
-
-            <nNumero>       Numero a convertir
-            <lFemenino>     = 'true' si el Literal es femenino
-                            P.e.:   201     -->    "doscientas una"
-        """
-        # Nos aseguramos del tipo de <nNumero>
-        # se podria adaptar para usar otros tipos (pe: float)
-        nNumero = long(nNumero)
-        if nNumero<0:       cRes = "menos "+self._amount_to_text(-nNumero,lFemenino)
-        elif nNumero==0:    cRes = "cero"
-        else:               cRes = self._amount_to_text(nNumero,lFemenino)
-        
-        # Excepciones a considerar
-        if not lFemenino and nNumero%10 == 1 and nNumero%100!=11:
-            cRes += "o"
-        #cRes = cRes.upper()
-        #cRes = cRes.capitalize()
-        return cRes
-    
-    # Funcion auxiliar recursiva
-    def _amount_to_text(self, n, lFemenino=0):
-    
-        # Localizar los billones    
-        prim,resto = divmod(n,10L**12)
-        if prim!=0:
-            if prim==1:     cRes = "un billon"
-            else:           cRes = self._amount_to_text(prim,0)+" billones" # Billones es masculino
-    
-            if resto!=0:    cRes += " "+self._amount_to_text(resto,lFemenino)
-    
-        else:
-        # Localizar millones
-            prim,resto = divmod(n,10**6)
-            if prim!=0:
-                if prim==1: cRes = "un millon"
-                else:       cRes = self._amount_to_text(prim,0)+" millones" # Millones es masculino
-    
-                if resto!=0: cRes += " " + self._amount_to_text(resto,lFemenino)
-    
-            else:
-            # Localizar los miles
-                prim,resto = divmod(n,10**3)
-                if prim!=0:
-                    if prim==1: cRes="un mil"
-                    else:       cRes=self._amount_to_text(prim,lFemenino)+" mil"
-    
-                    if resto!=0: cRes += " " + self._amount_to_text(resto,lFemenino)
-    
-                else:
-                # Localizar los cientos
-                    prim,resto=divmod(n,100)
-                    if prim!=0:
-                        if prim==1:
-                            if resto==0:        cRes="cien"
-                            else:               cRes="ciento"
-                        else:
-                            cRes=self._n3[prim-1]
-                            if lFemenino:       cRes+="ientas"
-                            else:               cRes+="ientos"
-    
-                        if resto!=0:  cRes+=" "+self._amount_to_text(resto,lFemenino)
-    
-                    else:
-                    # Localizar las decenas
-                        if lFemenino and n==1:              cRes="una"
-                        elif n<=20:                         cRes=self._n1[n-1]
-                        else:
-                            prim,resto=divmod(n,10)
-                            cRes=self._n2[prim-1]
-                            if resto!=0:
-                                if prim==2:                 cRes+=self._n11[resto-1]
-                                else:                       cRes+=" y "+self._n1[resto-1]
-    
-                                if lFemenino and resto==1:  cRes+="a"
-        return cRes
-    
-# Crear una demo interactiva
-if __name__=="__main__":
-    """
-    lFemenino=(raw_input("En masculino o femenino? ( [M] / F ) ") in "Ff")
-    num=raw_input("Dame un numero: ")
-    print amount_to_text(num,lFemenino)
-    raw_input("Presione cualquier tecla para continuar....")
-    """
-    #print amount_to_text().amount_to_text(5001)
-    letra = amount_to_text().amount_to_text_cheque(1500.25, 'pesos', 'M. N.')
-    letra = amount_to_text().amount_to_text(1500.25)
-    print letra.upper()

=== modified file 'l10n_mx_facturae_cbb/report/invoice_facturae_pdf.py'
--- l10n_mx_facturae_cbb/report/invoice_facturae_pdf.py	2012-02-24 00:42:55 +0000
+++ l10n_mx_facturae_cbb/report/invoice_facturae_pdf.py	2012-04-06 23:21:07 +0000
@@ -28,11 +28,11 @@
 from report import report_sxw
 import pooler
 import tools
-from amount_to_text_es import amount_to_text as amount_to_text_class
+#from amount_to_text_es import amount_to_text as amount_to_text_class
 
-amount_to_text_obj = amount_to_text_class()
+#amount_to_text_obj = amount_to_text_class()
 #amount_to_text = amount_to_text_obj.amount_to_text
-amount_to_text = amount_to_text_obj.amount_to_text_cheque
+#amount_to_text = amount_to_text_obj.amount_to_text_cheque
 
 ###sql_delete_report = "DELETE FROM ir_act_report_xml WHERE report_name = 'account.invoice.facturae.pdf'"--Si no toma la actualizacion del reporte xml, borrarlo directamente desde la base de datos, con este script.
 
@@ -42,7 +42,7 @@
         self.localcontext.update({
             'set_global_data': self._set_global_data,
             'facturae_data_dict': self._facturae_data_dict,
-            'amount_to_text': self._get_amount_to_text,
+            #'amount_to_text': self._get_amount_to_text,
             'split_string': self._split_string,
             'company_address': self._company_address,
             'subcompany_address': self._subcompany_address,
@@ -51,9 +51,21 @@
             'get_taxes': self._get_taxes,
             'get_taxes_ret': self._get_taxes_ret,
             'float': float,
+            'exists_key': self._exists_key,
         })
         self.taxes = []
     
+    def _exists_key(self, key):
+        return self.invoice._columns.has_key(key)
+        """
+        try:
+            str= 'self.invoice.'+key
+            if eval(str):
+                return True
+        except:
+            return False
+        """
+    
     def _set_global_data(self, o):
         try:
             self.setLang(o.partner_id.lang)
@@ -66,7 +78,7 @@
             print "exception: %s"%( e )
             pass
         try:
-            self._get_facturae_data_dict(o.id)
+            self._get_facturae_data_dict(o)
         except Exception, e:
             print "exception: %s"%( e )
             pass
@@ -79,21 +91,24 @@
         return self.sequence
     
     def _set_invoice_sequence_and_approval(self, invoice_id):
-        #TinyERP Compatibility
         context = {}
         pool = pooler.get_pool(self.cr.dbname)
         invoice_obj = pool.get('account.invoice')
         sequence_obj = pool.get('ir.sequence')
-        approval_obj = pool.get('ir.sequence.approval')
-        #invoice = invoice_obj.browse(self.cr, self.uid, invoice_id)
-        sequence_id = invoice_obj._get_invoice_sequence(self.cr, self.uid, [invoice_id])[invoice_id]
-        sequence = sequence_obj.browse(self.cr, self.uid, [sequence_id])[0]
+        #approval_obj = pool.get('ir.sequence.approval')
+        invoice = invoice_obj.browse(self.cr, self.uid, [invoice_id], context=context)[0]
+        context.update({'number_work': invoice.number})
+        sequence = invoice.invoice_sequence_id or False
+        sequence_id = sequence and sequence.id or False
+        #invoice_obj._get_invoice_sequence(self.cr, self.uid, [invoice_id])[invoice_id]
+        #sequence_obj.browse(self.cr, self.uid, [sequence_id])[0]
         self.sequence = sequence
         
-        invoice = invoice_obj.browse(self.cr, self.uid, [invoice_id])[0]
-        context.update({'number_work': invoice.number})
-        approval_id = sequence_obj._get_current_approval(self.cr, self.uid, [sequence_id], context=context)[sequence_id]
-        approval = approval_obj.browse(self.cr, self.uid, [approval_id])[0]
+        #invoice = invoice_obj.browse(self.cr, self.uid, [invoice_id])[0]
+        approval = sequence and sequence.approval_id or False
+        approval_id = approval and approval.id or False
+        #approval_id = sequence_obj._get_current_approval(self.cr, self.uid, [sequence_id], context=context)[sequence_id]
+        #approval = approval_obj.browse(self.cr, self.uid, [approval_id])[0]
         self.approval = approval
         return sequence, approval
     
@@ -107,12 +122,39 @@
             pass
         return []
     
+    '''
+    def _set_taxes(self, invoice_id):
+        """
+        pool = pooler.get_pool(self.cr.dbname)
+        invoice_obj = pool.get('account.invoice')
+        invoice = invoice_obj.browse(self.cr, self.uid, [invoice_id])[0]
+        taxes = []
+        for line_tax_id in invoice.tax_line:
+            tax_name = line_tax_id.name.lower().replace('.','').replace('-','').replace(' ', '')
+            if tax_name in ['iva']:
+                tax_name = 'IVA'
+            elif 'isr' in tax_name:
+                tax_name = 'ISR'
+            elif 'ieps' in tax_name:
+                tax_name = 'IEPS'
+            tax_names.append( tax_name )
+            taxes.append({
+                'name': tax_name,
+                'rate': "%.2f"%( round( line_tax_id.amount/(invoice.amount_total-line_tax_id.amount)*100, 0) ),
+                'amount': "%.2f"%( line_tax_id.amount or 0.0),
+            })
+        """
+        self.taxes = self.invoice_data_dict['Comprobante']['Impuestos']['Traslados']
+        #self.taxes = taxes
+        return taxes
+    '''
+    
     def _split_string(self, string, length=100):
         if string:
             for i in range(0, len(string), length):
                 string = string[:i] + ' ' + string[i:]
         return string
-        
+    """
     def _get_amount_to_text(self, amount, lang, currency=""):
         if currency.upper() in ('MXP', 'MXN', 'PESOS', 'PESOS MEXICANOS'):
             sufijo = 'M. N.'
@@ -123,7 +165,7 @@
         amount_text = amount_to_text(amount, currency, sufijo)
         amount_text = amount_text and amount_text.upper() or ''
         return amount_text
-    
+    """
     def _get_company_address(self, invoice_id):
         pool = pooler.get_pool(self.cr.dbname)
         invoice_obj = pool.get('account.invoice')
@@ -131,6 +173,9 @@
         address_obj = pool.get('res.partner.address')
         invoice = invoice_obj.browse(self.cr, self.uid, invoice_id)
         partner_id = invoice.company_id.parent_id and invoice.company_id.parent_id.partner_id.id or invoice.company_id.partner_id.id
+        self.invoice = invoice
+        #print "partner_id",partner_id
+        #invoice = partner_obj.browse(cr, uid, invoice_id)
         address_id = partner_obj.address_get(self.cr, self.uid, [partner_id], ['invoice'])['invoice']
         self.company_address_invoice = address_obj.browse(self.cr, self.uid, address_id)
         
@@ -140,31 +185,52 @@
         else:
             subaddress_id = partner_obj.address_get(self.cr, self.uid, [subpartner_id], ['invoice'])['invoice']
             self.subcompany_address_invoice = address_obj.browse(self.cr, self.uid, subaddress_id)
+        #print "self.company_address_invoice",self.company_address_invoice
+        #print "self.company_address_invoice[0]",self.company_address_invoice[0]
+        #self.company_address_invoice  = self.company_address_invoice and self.company_address_invoice[0] or False
+        #print "self.company_address_invoice",self.company_address_invoice
+        #return [self.company_address_invoice]
         return ""
     
     def _company_address(self):
+        #print "self.company_address_invoice",self.company_address_invoice
         return self.company_address_invoice
     
     def _subcompany_address(self):
         return self.subcompany_address_invoice
     
     def _facturae_data_dict(self):
+        #print "self.invoice_data_dict",self.invoice_data_dict
         return self.invoice_data_dict
     
-    def _get_facturae_data_dict(self, invoice_id):
+    def _get_facturae_data_dict(self, invoice):
+        self._set_invoice_sequence_and_approval( invoice.id )
+        #invoice_obj = pool.get('account.invoice')
+        self.taxes = [tax for tax in invoice.tax_line if tax.tax_percent > 0.01]
+        self.taxes_ret = [tax for tax in invoice.tax_line if tax.tax_percent <= 0.01]
+        return ""
+        """
         pool = pooler.get_pool(self.cr.dbname)
         invoice_obj = pool.get('account.invoice')
-        invoice_tax_obj = pool.get('account.invoice.tax')
+        self.invoice_data_dict = invoice_obj._get_facturae_invoice_xml_data(self.cr, self.uid, [invoice_id], context={'type_data': 'dict'})
+        #print "self.invoice_data_dict['Comprobante']['Impuestos']['Traslados']",self.invoice_data_dict['Comprobante']['Impuestos']['Traslados']
         try:
-            self._set_invoice_sequence_and_approval( invoice_id )
-        except:
-            print "report error: self._set_invoice_sequence_and_approval( invoice_id )"
+            self.taxes = [ traslado['Traslado'] for traslado in self.invoice_data_dict['Comprobante']['Impuestos']['Traslados'] if float( traslado['Traslado']['tasa'] ) >0.01 ]
+            #self.taxes = [tax for tax in invoice.account_invoice_tax if tax.tax_percent > 0.01]
+            #self.taxes.extend( self.taxes_ret )
+        except Exception, e:
+            print "exception: %s"%( e )
             pass
-        invoice = invoice_obj.browse(self.cr, self.uid, [invoice_id])[0]
-        tax_line_ids = [tax_line.id for tax_line in invoice.tax_line]
-        tax_datas = invoice_tax_obj._get_tax_data(self.cr, self.uid, tax_line_ids)
-        self.taxes = tax_datas.values()
+        
+        #self.taxes_ret = []
+        for retencion in self.invoice_data_dict['Comprobante']['Impuestos'].get('Retenciones', []):
+            amount_untaxed = float( self.invoice_data_dict['Comprobante']['subTotal'] )
+            tax_ret_amount = float( retencion['Retencion']['importe'] )
+            tasa = tax_ret_amount and amount_untaxed and tax_ret_amount * 100 / amount_untaxed or 0.0
+            retencion['Retencion'].update({'tasa':  tasa})
+            self.taxes_ret.append( retencion['Retencion'] )
         return ""
+        """
     
 report_sxw.report_sxw(
     'report.account.invoice.facturae.pdf2',

=== modified file 'l10n_mx_facturae_cbb/report/invoice_facturae_pdf.rml'
--- l10n_mx_facturae_cbb/report/invoice_facturae_pdf.rml	2012-03-12 19:21:56 +0000
+++ l10n_mx_facturae_cbb/report/invoice_facturae_pdf.rml	2012-04-06 23:21:07 +0000
@@ -52,16 +52,29 @@
     <paraStyle name="P7" fontName="Helvetica" fontSize="12.0" leading="15" textColor="#800000"/>
     <paraStyle name="P8" fontName="Helvetica" fontSize="2.0" leading="3" textColor="#800000"/>
     <paraStyle name="P9" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
-    <paraStyle name="P10" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
-    <paraStyle name="P11" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#280099"/>
-    <paraStyle name="P12" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="6.0" leading="8" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
-    <paraStyle name="P13" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="P10" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="6.0" leading="8" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="P11" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="P12" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#280099"/>
+    <paraStyle name="P13" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="18.0" leading="22" alignment="CENTER" spaceBefore="0.0" spaceAfter="0.0" textColor="#280099"/>
     <paraStyle name="P14" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#280099"/>
-    <paraStyle name="P15" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="18.0" leading="22" alignment="CENTER" spaceBefore="0.0" spaceAfter="0.0" textColor="#280099"/>
-    <paraStyle name="P16" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#280099"/>
-    <paraStyle name="P17" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="2.0" leading="3" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#280099"/>
-    <paraStyle name="P18" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#000000"/>
-    <paraStyle name="P19" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="RIGHT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="P15" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="2.0" leading="3" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#280099"/>
+    <paraStyle name="P16" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#000000"/>
+    <paraStyle name="P17" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="RIGHT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="P18" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#280099"/>
+    <paraStyle name="P19" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#280099"/>
+    <paraStyle name="P20" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="2.0" leading="3" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#280099"/>
+    <paraStyle name="P21" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="2.0" leading="3" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#280099"/>
+    <paraStyle name="P22" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="P23" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#000000"/>
+    <paraStyle name="P24" fontName="Helvetica" textColor="#280099"/>
+    <paraStyle name="P25" fontName="Helvetica" alignment="RIGHT" textColor="#280099"/>
+    <paraStyle name="P26" fontName="Helvetica" fontSize="8.0" leading="10"/>
+    <paraStyle name="P27" fontName="Helvetica" fontSize="10.0" leading="13"/>
+    <paraStyle name="P28" fontName="Helvetica" alignment="RIGHT"/>
+    <paraStyle name="P29" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0" textColor="#280099"/>
+    <paraStyle name="P30" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="P31" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="8.0" leading="10" alignment="LEFT" spaceBefore="0.0" spaceAfter="0.0"/>
+    <paraStyle name="P32" rightIndent="0.0" leftIndent="0.0" fontName="Helvetica" fontSize="9.0" leading="11" alignment="CENTER" spaceBefore="0.0" spaceAfter="0.0"/>
     <paraStyle name="Standard" fontName="Helvetica"/>
     <paraStyle name="Heading" fontName="Helvetica" fontSize="14.0" leading="17" spaceBefore="12.0" spaceAfter="6.0"/>
     <paraStyle name="Text body" fontName="Helvetica" spaceBefore="0.0" spaceAfter="6.0"/>
@@ -78,42 +91,46 @@
   </stylesheet>
   <story>
     <section>
-      <para style="P12">[[ repeatIn(objects,'o') ]] <font face="Helvetica" size="9.0">[[ set_global_data(o) ]]</font></para>
-      <para style="P15">[[ o.company_id.parent_id and o.company_id.parent_id.partner_id.name or o.company_id.partner_id.name ]]</para>
+      <para style="P10">[[ repeatIn(objects,'o') ]] <font face="Helvetica" size="9.0">[[ set_global_data(o) ]]</font></para>
+      <para style="P13">[[ o.company_id.parent_id and o.company_id.parent_id.partner_id.name or o.company_id.partner_id.name ]]</para>
       <blockTable colWidths="125.0,207.0,166.0" style="Tabla1">
         <tr>
           <td>
-            <para style="P19">[[ o.company_id.logo and setTag('para','image',{'width':'120.0','height':'80.0'}) ]] [[ o.company_id.logo ]]</para>
+            <para style="P17">[[ o.company_id.logo and setTag('para','image',{'width':'120.0','height':'80.0'}) ]] [[ o.company_id.logo ]]</para>
           </td>
           <td>
-            <para style="P14">[[ company_address()['name'] or o.company_id.partner_id.name ]]</para>
-            <para style="P17">
-              <font color="white"> </font>
-            </para>
-            <para style="P14">[[ company_address()['street'] or '' ]]</para>
-            <para style="P17">
-              <font color="white"> </font>
-            </para>
-            <para style="P14">[[ company_address()['street2'] or '' ]]</para>
-            <para style="P17">
-              <font color="white"> </font>
-            </para>
-            <para style="P14">[[ company_address()['city'] or '' ]], [[ company_address()['state_id'] and company_address()['state_id']['name'] or '' ]]</para>
-            <para style="P17">
-              <font color="white"> </font>
-            </para>
-            <para style="P14">CP [[ company_address()['zip'] or '' ]]</para>
-            <para style="P17">
-              <font color="white"> </font>
-            </para>
-            <para style="P14">RFC : [[ o.company_id.partner_id._columns.has_key('vat_split') and o.company_id.partner_id.vat_split or o.company_id.partner_id.vat ]]</para>
-            <para style="P17">
-              <font color="white"> </font>
-            </para>
-            <para style="P16">Teléfono(s): </para>
-            <para style="P16">[[ company_address()['phone'] or removeParentNode('para') ]]</para>
-            <para style="P16">[[ company_address()['fax'] or removeParentNode('para') ]]</para>
-            <para style="P16">[[ company_address()['mobile'] or removeParentNode('para') ]]</para>
+            <para style="P12">[[ company_address()['name'] or o.company_id.partner_id.name ]]</para>
+            <para style="P15">
+              <font color="white"> </font>
+            </para>
+            <para style="P12">Calle: [[ company_address()['street'] or '' ]] Nro. Ext: [[ company_address()['street3'] or '' ]] Int: [[ company_address()['street4'] or '' ]]</para>
+            <para style="P15">
+              <font color="white"> </font>
+            </para>
+            <para style="P12">Colonia: [[ company_address()['street2'] or '' ]]</para>
+            <para style="P15">
+              <font color="white"> </font>
+            </para>
+            <para style="P12">Ciudad: [[ company_address()['city'] or '' ]] Estado: [[ company_address()['state_id'] and company_address()['state_id']['name'] or '' ]]</para>
+            <para style="P21">
+              <font color="white"> </font>
+            </para>
+            <para style="P12">Localidad: [[ company_address()['city2'] or '' ]]</para>
+            <para style="P15">
+              <font color="white"> </font>
+            </para>
+            <para style="P12">CP: [[ company_address()['zip'] or '' ]]</para>
+            <para style="P15">
+              <font color="white"> </font>
+            </para>
+            <para style="P12">RFC: [[ o.company_id.partner_id._columns.has_key('vat_split') and o.company_id.partner_id.vat_split or o.company_id.partner_id.vat ]]</para>
+            <para style="P15">
+              <font color="white"> </font>
+            </para>
+            <para style="P14">Teléfono(s): </para>
+            <para style="P14">[[ company_address()['phone'] or removeParentNode('para') ]]</para>
+            <para style="P14">[[ company_address()['fax'] or removeParentNode('para') ]]</para>
+            <para style="P14">[[ company_address()['mobile'] or removeParentNode('para') ]]</para>
           </td>
           <td>
             <para style="P6">
@@ -136,24 +153,28 @@
           <td>
             <para style="P4">Receptor</para>
             <para style="Table Contents"><font face="Helvetica">Nombre: </font>[[ o.partner_id.name ]]</para>
-            <para style="terp_default_8"><font face="Helvetica">Dirección:</font> [[ o.address_invoice_id.street ]]</para>
+            <para style="terp_default_8"><font face="Helvetica">Dirección:</font> [[ o.address_invoice_id.street ]] No. Ext: [[ o.address_invoice_id.street3 ]] Int: [[ o.address_invoice_id.street4 ]]</para>
             <para style="terp_default_8"><font face="Helvetica">Colonia:</font> [[ o.address_invoice_id.street2 or '' ]]</para>
-            <para style="terp_default_8"><font face="Helvetica">Ciudad:</font> [[ o.address_invoice_id.city or '' ]], [[ o.address_invoice_id.state_id and o.address_invoice_id.state_id.name or '' ]]</para>
+            <para style="terp_default_8"><font face="Helvetica">Ciudad:</font> [[ o.address_invoice_id.city or '' ]] <font face="Helvetica">Estado: </font>[[ o.address_invoice_id.state_id and o.address_invoice_id.state_id.name or '' ]]</para>
+            <para style="terp_default_8"><font face="Helvetica">Localidad: </font>[[ o.address_invoice_id.city2 or '' ]]</para>
             <para style="terp_default_8"><font face="Helvetica">C.P.:</font> [[ o.address_invoice_id.zip or '' ]] </para>
             <para style="terp_default_8"><font face="Helvetica">R. F. C. :</font> [[ o.partner_id._columns.has_key('vat_split') and o.partner_id.vat_split or o.partner_id.vat ]]</para>
-            <para style="P18">Teléfono(s): </para>
-            <para style="P13">[[ o.address_invoice_id.phone or removeParentNode('para') ]]</para>
-            <para style="P13">[[ o.address_invoice_id.fax or removeParentNode('para') ]]</para>
-            <para style="P13">[[ o.address_invoice_id.mobile or removeParentNode('para') ]]</para>
+            <para style="P16">Teléfono(s): </para>
+            <para style="P11">[[ o.address_invoice_id.phone or removeParentNode('para') ]]</para>
+            <para style="P11">[[ o.address_invoice_id.fax or removeParentNode('para') ]]</para>
+            <para style="P11">[[ o.address_invoice_id.mobile or removeParentNode('para') ]]</para>
           </td>
           <td>
             <para style="Table Contents">Condición de pago: [[ format(o.payment_term and (o.payment_term.note or o.payment_term.name) or removeParentNode('para') ) ]]</para>
             <para style="P3">Origen: [[ o.origin or removeParentNode('para') ]]</para>
             <para style="P3">Expedido en:</para>
             <para style="P3">[[ subcompany_address()['name'] or o.company_id.partner_id.name ]]</para>
-            <para style="P3">[[ subcompany_address()['street'] or '' ]], [[ subcompany_address()['street2'] or '' ]]</para>
-            <para style="P3">[[ subcompany_address()['city'] or '' ]], [[ subcompany_address()['state_id'] and subcompany_address()['state_id']['name'] or '' ]]</para>
-            <para style="P3">CP [[ subcompany_address()['zip'] or '' ]] </para>
+            <para style="P3">Calle: [[ subcompany_address()['street'] or '' ]] Nro. Ext: [[ subcompany_address()['street3'] or '' ]] Int: [[ subcompany_address()['street4'] or '' ]]</para>
+            <para style="P3">Colonia: [[ subcompany_address()['street2'] or '' ]]</para>
+            <para style="P3">Ciudad: [[ subcompany_address()['city'] or '' ]] </para>
+            <para style="P3">Estado: [[ subcompany_address()['state_id'] and subcompany_address()['state_id']['name'] or '' ]]</para>
+            <para style="P3">Localidad: [[ subcompany_address()['city2'] or '' ]]</para>
+            <para style="P3">CP: [[ subcompany_address()['zip'] or '' ]] </para>
           </td>
         </tr>
       </blockTable>
@@ -187,6 +208,10 @@
           </td>
           <td>
             <para style="Table Contents">[[ l.name ]]</para>
+            <para style="P27">
+              <font face="Helvetica" size="7.0">Notas:</font>
+              <font face="Helvetica" size="7.0">[[l.note or removeParentNode('para')]]</font>
+            </para>
           </td>
           <td>
             <para style="Table Contents">[[ l.product_id and l.product_id.default_code ]]</para>
@@ -195,13 +220,29 @@
             <para style="P1">[[ formatLang(l.price_unit) ]]</para>
           </td>
           <td>
-            <para style="P1">[[ formatLang(l.price_subtotal) ]]</para>
+            <para style="P1">[[ exists_key('global_discount_percent') and (formatLang(l.quantity * l.price_unit, digits=get_digits(dp='Account'))) or formatLang(l.price_subtotal) ]]</para>
           </td>
         </tr>
       </blockTable>
       <blockTable colWidths="427.0,71.0" style="Tabla7">
         <tr>
           <td>
+            <para style="P5">Suma $</para>
+          </td>
+          <td>
+            <para style="P1">[[formatLang( ( exists_key('global_discount_percent') and o.global_discount_amount or 0.0 ) + (o.amount_untaxed or 0.0), digits=get_digits(dp='Account') )]]</para>
+          </td>
+        </tr>
+        <tr>
+          <td>
+            <para style="P5">Descuento: [[ exists_key('global_discount_percent') and o.global_discount_percent or removeParentNode('tr')]] %</para>
+          </td>
+          <td>
+            <para style="P1">[[o.global_discount_amount and formatLang( o.global_discount_amount) or '']]</para>
+          </td>
+        </tr>
+        <tr>
+          <td>
             <para style="P5">Sub Total $</para>
           </td>
           <td>
@@ -212,7 +253,7 @@
           <td>
             <para style="P5">
               <font face="Helvetica" size="6.0">[[ repeatIn( get_taxes(), 'tax' ) ]]</font>
-              <font face="Helvetica">[[ tax['name2'] ]] ([[ tax['percent'] ]]%) $</font>
+              <font face="Helvetica">[[ tax['name2'] ]] ([[ round( float( tax['tax_percent'] ) ) ]]%) $</font>
             </para>
           </td>
           <td>
@@ -221,6 +262,17 @@
         </tr>
         <tr>
           <td>
+            <para style="P5">
+              <font face="Helvetica" size="6.0">[[ repeatIn( get_taxes_ret(), 'tax_ret' ) ]]</font>
+              <font face="Helvetica">[[ tax_ret['name2'] ]] Ret ([[ round( float( tax_ret['tax_percent'] ),2 )*-1 ]]%) $</font>
+            </para>
+          </td>
+          <td>
+            <para style="P1">[[ formatLang( float( tax_ret['amount'] )*-1 ) ]]</para>
+          </td>
+        </tr>
+        <tr>
+          <td>
             <para style="P5">Total $</para>
           </td>
           <td>
@@ -229,8 +281,8 @@
         </tr>
         <tr>
           <td>
-            <para style="P11">IMPORTE CON LETRA:</para>
-            <para style="P10">[[ amount_to_text(o.amount_total, 'es_cheque', o.currency_id._columns.has_key('code') and o.currency_id.code or o.currency_id.name) ]]</para>
+            <para style="P29">IMPORTE CON LETRA:</para>
+            <para style="P31">[[ o.amount_to_text ]]</para>
           </td>
           <td>
             <para style="P1">
@@ -239,6 +291,7 @@
           </td>
         </tr>
       </blockTable>
+      <para style="P9"/>
       <para style="P9">
         <font color="white"> </font>
       </para>
@@ -271,6 +324,10 @@
           </td>
         </tr>
       </blockTable>
+      <para style="terp_default_9">
+        <font color="white"> </font>
+      </para>
+      <para style="P32">Vendedor: [[o.user_id.name]]</para>
       <para style="terp_default_9">[[ format(o.comment or '') ]]</para>
     </section>
     <para style="Standard">

=== modified file 'l10n_mx_facturae_cbb/report/invoice_facturae_pdf.sxw'
Binary files l10n_mx_facturae_cbb/report/invoice_facturae_pdf.sxw and l10n_mx_facturae_cbb/report/invoice_facturae_pdf.sxw differ
